class GDAXClient
  module Controls
    module HTTP
      module ProductTicker
        module Get
          module Response
            def self.example
              Success.example
            end

            module Success
              def self.example
                response = GDAXClient::HTTP::ProductTicker::Get::Response.build
                response.data = GDAXClient::HTTP::ProductTicker::Get::Response::Data.build

                response.data.trade_id = Ticker::TradeID.example
                response.data.price = Ticker::Price.example
                response.data.size = Ticker::Size.example
                response.data.bid = Ticker::Bid.example
                response.data.ask = Ticker::Ask.example
                response.data.volume = Ticker::Volume.example
                response.data.time = Time.example

                response.status_code = StatusCode.sample
                response.message = Message.sample

                response
              end

              module StatusCode
                def self.sample
                  '200'
                end
              end

              module Message
                def self.sample
                  'OK'
                end
              end
            end

            module Failure
              def self.example
                response = GDAXClient::HTTP::ProductTicker::Get::Response.build

                response.status_code = StatusCode.sample
                response.message = Message.sample

                response
              end

              module StatusCode
                def self.sample
                  '404'
                end
              end

              module Message
                def self.sample
                  'Not Found'
                end
              end
            end

            module JSON
              def self.text
                ::JSON.generate(data)
              end

              def self.data
                {
                  'trade_id' => Ticker::TradeID.example,
                  'price' => Ticker::Price.example,
                  'size' => Ticker::Size.example,
                  'bid' => Ticker::Bid.example,
                  'ask' => Ticker::Ask.example,
                  'volume' => Ticker::Volume.example,
                  'time' => Time.example
                }
              end
            end
          end
        end
      end
    end
  end
end
