class GDAXClient
  module HTTP
    module ProductTicker
      class Get
        class Response
          include Schema::DataStructure

          attribute :data
          attribute :status_code
          attribute :message

          class Data
            include Schema::DataStructure

            attribute :trade_id
            attribute :price
            attribute :size
            attribute :bid
            attribute :ask
            attribute :volume
            attribute :time
          end

          module Transformer
            def self.json
              JSON
            end

            def self.instance(raw_data)
              response = Response.build
              response.data = Response::Data.build(raw_data)
              response
            end

            module JSON
              def self.read(text)
                ::JSON.parse text, :symbolize_names => true
              end
            end
          end
        end
      end
    end
  end
end
